#include "kontyrawindow.h"
#include "ui_kontyrawindow.h"
#include <QClipboard>
#include <QDir>
#include <QDesktopServices>
#include <QFileDialog>
#include <QThread>
#include <QInputDialog>

KontyraWindow::KontyraWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::KontyraWindow)
{
    ui->setupUi(this);
    scene=new QGraphicsScene;
    scene2=new QGraphicsScene;
    ui->graphicsView->sinhron=ui->graphicsView_2;
    ui->graphicsView_2->sinhron=ui->graphicsView;
    scene3=new QGraphicsScene;
    cur="";
    one_more=new QThread;
    convert= new ConvertThread;
    convert->moveToThread(one_more);
    ui->label->setAlignment(Qt::AlignCenter);
    ui->label_2->setAlignment(Qt::AlignCenter);
    ui->label_3->setAlignment(Qt::AlignCenter);


    connect(this,SIGNAL(chryashchev(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(chryashchev(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(sharr(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(sharr(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(sobel(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(sobel(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(pryitt(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(pryitt(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(roberts(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(roberts(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(robertsBistrij(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(robertsBistrij(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(laplasian(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(laplasian(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(kirsh(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(kirsh(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(robinson(QImage , unsigned int , unsigned int , unsigned int , unsigned int )),
            convert,SLOT(robinson(QImage , unsigned int , unsigned int , unsigned int , unsigned int )));
    connect(this,SIGNAL(tolkoSeriy(QImage ,unsigned int , unsigned int )),
            convert,SLOT(tolkoSeriy(QImage ,unsigned int , unsigned int )));

    connect(this,SIGNAL(S333433(QImage )),convert,SLOT(S333433(QImage )));
    connect(this,SIGNAL(S305911(QImage )),convert,SLOT(S305911(QImage )));
    connect(this,SIGNAL(S345016(QImage )),convert,SLOT(S345016(QImage )));
    connect(convert,SIGNAL(obr_exit(QImage )),this,SLOT(obr_exit(QImage )));

    connect(convert,SIGNAL(alg_exit(QImage ,unsigned int ,unsigned int)),
            this,SLOT(alg_exit(QImage ,unsigned int ,unsigned int)));


    connect(this,SIGNAL(monochrom(bool, QImage , unsigned int , unsigned int )),
            convert, SLOT(monochrom(bool, QImage , unsigned int , unsigned int )));
    connect(convert,SIGNAL(monochrom_exit(QImage , unsigned int , unsigned int )),
            this,SLOT(monochrom_exit(QImage , unsigned int , unsigned int )));

    connect(this,SIGNAL(inversia(QImage , unsigned int , unsigned int )),
            convert, SLOT(inversia(QImage , unsigned int , unsigned int )));
    connect(convert,SIGNAL(inversia_exit(QImage , unsigned int , unsigned int )),
            this,SLOT(inversia_exit(QImage , unsigned int , unsigned int )));

    connect(this,SIGNAL(postroimGradient(unsigned int , unsigned int , unsigned int )),
            convert, SLOT(postroimGradient(unsigned int , unsigned int , unsigned int )));
    connect(convert,SIGNAL(postroimGradient_exit(QImage , unsigned int , unsigned int )),
            this,SLOT(postroimGradient_exit(QImage , unsigned int , unsigned int )));

    one_more->start(QThread::NormalPriority);

    QGraphicsTextItem *pic_text;
    pic_text=scene3->addText("Откройте изображение!",QFont("Inconsolata",12,QFont::Bold));
    pic_text->setDefaultTextColor(0xFFFF4F00);
    ui->graphicsView_3->setScene(scene3);

    a0h=12962;
    a1h=4829;
    a2h=1144;
    a3h=809;
    a4h=361;
    a5h=511;
    a6h=1023;
    a7h=3839;
    a8h=1023;

    a0l=a1l=a2l=a3l=a4l=a5l=a6l=a7l=a8l=0;

    ui->comboBox->setCurrentIndex(2);
}

KontyraWindow::~KontyraWindow()
{
    delete scene;
    delete scene2;
    delete scene3;
    one_more->exit(0);
    delete one_more;
    delete ui;
}

void KontyraWindow::showEvent(QShowEvent *)
{
    ui->graphicsView_3->fitInView(scene3->sceneRect(),Qt::KeepAspectRatio);
}

void KontyraWindow::resizeEvent(QResizeEvent* )
{
    //подгоняет размер картинки под размер окна, при событии изменения размера окна
    ui->graphicsView->fitInView(scene->sceneRect(),Qt::KeepAspectRatio);
    ui->graphicsView_2->fitInView(scene2->sceneRect(),Qt::KeepAspectRatio);
    ui->graphicsView_3->fitInView(scene3->sceneRect(),Qt::KeepAspectRatio);
}

void KontyraWindow::poluchitb_granicy()
{
    if (guard.tryLock())
    {
        if(picture1.width()==0||picture1.height()==0)
        {
            guard.unlock();
            return;
        }

        unsigned int min_porog=ui->dial_2->value();;
        unsigned int max_porog=ui->dial->value();

        ui->comboBox->setEnabled(false);
        ui->comboBox_2->setEnabled(false);
        ui->comboBox_3->setEnabled(false);
        time.restart();
        //при изменении менять значение и в postroimGradient
        switch (ui->comboBox->currentIndex())
        {
        case 0:
            emit chryashchev(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 1:
            emit sharr(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 2:
            emit sobel(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 3:
            emit pryitt(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 4:
            emit roberts(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 5:
            emit robertsBistrij(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 6:
            emit laplasian(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 7:
            emit kirsh(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        case 8:
            emit robinson(imagegray,min_porog,max_porog,ui->spinBox_2->value(),ui->spinBox->value());
            break;
        default:
            emit tolkoSeriy(imagegray , min_porog, max_porog);
            break;
        }
    }
}

void KontyraWindow::alg_exit(QImage new_image, unsigned int min_porog,
                             unsigned int max_porog)
{
    unsigned int new_min_porog=ui->dial_2->value();
    unsigned int new_max_porog=ui->dial->value();

    if (min_porog!=new_min_porog||max_porog!=new_max_porog)
        this->poluchitb_granicy();


    ui->label->setText("<html><head/><body><p align='center'><span style=' font-weight:600;'>"+
                       QString::number(time.elapsed())+" мс</span></p></body></html>");

    if (ui->checkBox->isChecked())
    {
        emit inversia(new_image,min_porog,max_porog);
        return;
    }
    else
    {
        if (ui->checkBox_2->isChecked())
        {
            emit monochrom(false, new_image,min_porog,max_porog);
            return;
        }
    }


    scene2->clear();
    QPixmap new_picture;
    new_picture=QPixmap::fromImage(new_image);
    scene2->addPixmap(new_picture);
    ui->graphicsView_2->setScene(scene2);

    if (!ui->graphicsView_3->otkl)
    {
        emit postroimGradient(new_image.width()*new_image.height(),min_porog,max_porog);
        return;
    }


    ui->comboBox->setEnabled(true);
    ui->comboBox_2->setEnabled(true);
    ui->comboBox_3->setEnabled(true);
    guard.unlock();


    new_min_porog=ui->dial_2->value();;
    new_max_porog=ui->dial->value();;

    if (min_porog!=new_min_porog||max_porog!=new_max_porog)
        this->poluchitb_granicy();
}

void KontyraWindow::postroimGradient_exit(QImage new_image,unsigned int min_porog,
                                          unsigned int max_porog)
{
    scene3->clear();

    QGraphicsPixmapItem *item;

    if (ui->checkBox_5->isChecked())
    {
        int height;
        if (new_image.height()<info_alg.height())
        {
            height=info_alg.height();
            info_alg=info_alg.scaled(info_alg.width()*(info_alg.height()/height),height,Qt::KeepAspectRatioByExpanding);
            scene3->setSceneRect(0,0,new_image.width()+info_alg.width()+8,height);
            item=scene3->addPixmap(info_alg);
            item->setX(515);
            item->setY(0);
            QPixmap gradient=QPixmap::fromImage(new_image);
            item=scene3->addPixmap(gradient);
            item->setY(height/2-new_image.height()/2);
        }
        else
        {
            height=new_image.height();
            scene3->setSceneRect(0,0,new_image.width()+info_alg.width()+8,height);
            item=scene3->addPixmap(info_alg);
            item->setX(515);
            item->setY(height/2-info_alg.height()/2);
            QPixmap gradient=QPixmap::fromImage(new_image);
            item=scene3->addPixmap(gradient);
            item->setY(height-new_image.height());
        }
    }
    else
    {
        scene3->setSceneRect(0,0,new_image.width(),new_image.height());
        QPixmap gradient=QPixmap::fromImage(new_image);
        scene3->addPixmap(gradient);
    }

    ui->graphicsView_3->setScene(scene3);
    ui->graphicsView_3->fitInView(scene3->sceneRect(),Qt::KeepAspectRatio);

    ui->comboBox->setEnabled(true);
    ui->comboBox_2->setEnabled(true);
    ui->comboBox_3->setEnabled(true);
    guard.unlock();


    unsigned int new_min_porog=ui->dial_2->value();
    unsigned int new_max_porog=ui->dial->value();

    if (min_porog!=new_min_porog||max_porog!=new_max_porog)
        this->poluchitb_granicy();
}

void KontyraWindow::monochrom_exit(QImage new_image,unsigned int min_porog,
                                   unsigned int max_porog)
{
    scene2->clear();
    QPixmap new_picture;
    new_picture=QPixmap::fromImage(new_image);
    scene2->addPixmap(new_picture);
    ui->graphicsView_2->setScene(scene2);

    if (!ui->graphicsView_3->otkl)
    {
        emit postroimGradient(new_image.width()*new_image.height(),min_porog,max_porog);
        return;
    }


    ui->comboBox->setEnabled(true);
    ui->comboBox_2->setEnabled(true);
    ui->comboBox_3->setEnabled(true);
    guard.unlock();


    unsigned int new_min_porog=ui->dial_2->value();
    unsigned int new_max_porog=ui->dial->value();

    if (min_porog!=new_min_porog||max_porog!=new_max_porog)
        this->poluchitb_granicy();
}

void KontyraWindow::inversia_exit(QImage new_image,unsigned int min_porog,
                                  unsigned int max_porog)
{
    if (ui->checkBox_2->isChecked())
    {
        emit monochrom(true,new_image,min_porog,max_porog);
        return;
    }


    scene2->clear();
    QPixmap new_picture;
    new_picture=QPixmap::fromImage(new_image);
    scene2->addPixmap(new_picture);
    ui->graphicsView_2->setScene(scene2);

    if (!ui->graphicsView_3->otkl)
    {
        emit postroimGradient(new_image.width()*new_image.height(),min_porog,max_porog);
        return;
    }


    ui->comboBox->setEnabled(true);
    ui->comboBox_2->setEnabled(true);
    ui->comboBox_3->setEnabled(true);
    guard.unlock();


    unsigned int new_min_porog=ui->dial_2->value();
    unsigned int new_max_porog=ui->dial->value();

    if (min_porog!=new_min_porog||max_porog!=new_max_porog)
        this->poluchitb_granicy();
}

void KontyraWindow::mousePressEvent(QMouseEvent *)
{
    if (ui->graphicsView_3->otkl) ui->checkBox_5->setEnabled(false);
    else
    {
        if (!ui->checkBox_5->isEnabled()) this->poluchitb_granicy();
        ui->checkBox_5->setEnabled(true);
    }
}

void KontyraWindow::on_comboBox_currentIndexChanged(int index)
{
    //при изменении менять значение и в postroimGradient
    unsigned int buf=0;
    bool lock=false;
    switch (index)
    {
    case 0:
        info_alg.load(":/Alg_pic/0Chryashchev.jpg");
        buf=a0h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(12962);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a0l);
        break;
    case 1:
        info_alg.load(":/Alg_pic/1Sharr.jpg");
        buf=a1h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(4829);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a1l);
        break;
    case 2:
        info_alg.load(":/Alg_pic/2Sobel.jpg");
        buf=a2h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(1144);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a2l);
        break;
    case 3:
        info_alg.load(":/Alg_pic/3Pryitt.jpg");
        buf=a3h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(809);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a3l);
        break;
    case 4:
        info_alg.load(":/Alg_pic/4Roberts.jpg");
        buf=a4h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(361);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a4l);
        break;
    case 5:
        info_alg.load(":/Alg_pic/5Roberts(bistrij).jpg");
        buf=a5h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(511);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a5l);
        break;
    case 6:
        info_alg.load(":/Alg_pic/6Laplasian.jpg");
        buf=a6h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(1023);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a6l);
        break;
    case 7:
        info_alg.load(":/Alg_pic/7Kirsh.jpg");
        buf=a7h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(3839);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a7l);
        break;
    case 8:
        info_alg.load(":/Alg_pic/8Robinson.jpg");
        buf=a8h;
        lock=guard.tryLock();
        ui->spinBox->setMaximum(1023);
        ui->spinBox->setValue(buf);
        if (lock) guard.unlock();
        ui->spinBox_2->setValue(a8l);
        break;
    }

    poluchitb_granicy();
}

void KontyraWindow::on_pushButton_2_clicked()
{
    if (!guard.tryLock()) return;

    cur.remove(cur.lastIndexOf("/")+1,cur.length()-cur.lastIndexOf("/")-1);
    cur=QFileDialog::getOpenFileName(this,"Выберите изображение",cur,
                                     "Картинки (*.bmp *.gif *.jpg *.jpeg *.png *.pbm *pgm *ppm "
                                     "*.ico *.tiff *.svg *.tga *.xbm *xpm);;Все файлы (*)");
    if(cur!="")
    {
        scene->clear();
        scene2->clear();

        picture1.load(cur);

        scene->setSceneRect(0,0,picture1.width(),picture1.height());
        scene2->setSceneRect(0,0,picture1.width(),picture1.height());
        scene->addPixmap(picture1);
        ui->graphicsView->setScene(scene);
        ui->graphicsView_2->setScene(scene2);
        ui->graphicsView->fitInView(scene->sceneRect(),Qt::KeepAspectRatio);
        ui->graphicsView_2->fitInView(scene2->sceneRect(),Qt::KeepAspectRatio);


        //создаем формат изображения
        QImage buf_image(picture1.width(),picture1.height(),QImage::Format_ARGB32_Premultiplied);
        //заливаем белый слой
        buf_image.fill(QColor(Qt::white));
        //создаем рисовальщика с данным изображением image1
        QPainter painter(&buf_image);
        //рисуем (а не перезаписываем) на белом фоне другое изображение
        //если этого не сделать, то png будут в прозрачных областях - черные.
        painter.drawImage(0, 0, picture1.toImage());
        image1=buf_image;

        ui->comboBox->setEnabled(false);
        ui->comboBox_2->setEnabled(false);
        ui->comboBox_3->setEnabled(false);
        switch (ui->comboBox_3->currentIndex())
        {
        default:
            emit S345016(image1);
            break;
        case 1:
            emit S333433(image1);
            break;
        case 2:
            emit S305911(image1);
            break;
        }
    }
    else guard.unlock();
}

void KontyraWindow::obr_exit(QImage new_image)
{
    imagegray=new_image;
    ui->comboBox->setEnabled(true);
    ui->comboBox_2->setEnabled(true);
    ui->comboBox_3->setEnabled(true);
    guard.unlock();
    this->poluchitb_granicy();
}

void KontyraWindow::on_pushButton_clicked()
{
    if (!guard.tryLock()) return;

    if(picture1.width()==0||picture1.height()==0)
    {
        guard.unlock();
        return;
    }


    QDateTime real_vremya;
    if (ui->radioButton->isChecked())
    {
        real_vremya=QDateTime::currentDateTime();

        cur.remove(cur.lastIndexOf("/")+1,cur.length()-cur.lastIndexOf("/")-1);
        cur=QFileDialog::getSaveFileName(this,"Сохранение изображения контура",cur+
                                         "Контур"+real_vremya.toString(" dd.MM.yy [hh-mm-ss]"),
                                         "BMP (*.bmp);;JPG (*.jpg);;JPEG (*.jpeg);;PNG (*.png)");

        if(cur!="")
        {
            if (ui->graphicsView_3->otkl)
            {
                QImage buf_image(scene2->width(),scene2->height(),QImage::Format_ARGB32_Premultiplied);
                QPainter painter(&buf_image);
                painter.setRenderHint(QPainter::HighQualityAntialiasing);
                scene2->render(&painter,QRectF(0,0,scene2->width(),scene2->height()),
                               QRectF(0,0,scene2->width(),scene2->height()),Qt::KeepAspectRatio);
                buf_image.save(cur);
            }
            else
            {
                int height, width;
                if (scene2->width()>scene3->width()) width=scene2->width();
                else  width=scene3->width();
                height=scene2->height()+scene3->height();

                QImage buf_image(width,height,QImage::Format_ARGB32_Premultiplied);
                buf_image.fill(Qt::white);
                QPainter painter(&buf_image);
                painter.setRenderHint(QPainter::HighQualityAntialiasing);

                if (scene2->width()>scene3->width())
                {
                    scene2->render(&painter,QRectF(0,0,scene2->width(),scene2->height()),
                                   QRectF(0,0,scene2->width(),scene2->height()),Qt::KeepAspectRatio);
                    scene3->render(&painter,QRectF(scene2->width()/2-scene3->width()/2,scene2->height(),
                                                   scene2->width()/2-scene3->width()/2+scene3->width(),scene3->height()),
                                   QRectF(0,0,scene3->width(),scene3->height()),Qt::KeepAspectRatio);
                }
                else
                {
                    scene2->render(&painter,QRectF(scene3->width()/2-scene2->width()/2,0,
                                                   scene3->width()/2-scene2->width()/2+scene2->width(),scene2->height()),
                                   QRectF(0,0,scene2->width(),scene2->height()),Qt::KeepAspectRatio);
                    scene3->render(&painter,QRectF(0,scene2->height(),scene3->width(),scene3->height()),
                                   QRectF(0,0,scene3->width(),scene3->height()),Qt::KeepAspectRatio);
                }

                buf_image.save(cur);
            }
        }
    }

    if (ui->radioButton_2->isChecked())
    {
        real_vremya=QDateTime::currentDateTime();

        cur.remove(cur.lastIndexOf("/")+1,cur.length()-cur.lastIndexOf("/")-1);
        cur=QFileDialog::getSaveFileName(this,"Сохранение координат контура",cur+
                                         "Контур"+real_vremya.toString(" dd.MM.yy [hh-mm-ss]"),
                                         "Текст (*.txt)");

        if(cur!="")
        {
            QFile file(cur);
            if (file.open(QIODevice::WriteOnly))
            {
                QImage buf_image(scene2->width(),scene2->height(),QImage::Format_Grayscale8);
                QPainter painter(&buf_image);
                painter.setRenderHint(QPainter::HighQualityAntialiasing);
                scene2->render(&painter,QRectF(0,0,scene2->width(),scene2->height()),
                               QRectF(0,0,scene2->width(),scene2->height()),Qt::KeepAspectRatio);

                QString coord_out;
                QTextStream potok_v_file(&file);
                for (int j=0;j<scene2->height();j++)
                    for (int i=0;i<scene2->width();i++)
                    {
                        if (buf_image.pixel(i,j)!=0xFF000000)
                        {
                            coord_out=QString::number(i)+" "+QString::number(j)+"\r\n";
                            potok_v_file<<coord_out;
                        }
                    }
                file.close();
            }
        }
    }

    if (!ui->graphicsView_3->otkl)
    {

    }

    guard.unlock();
}

void KontyraWindow::on_checkBox_2_clicked()
{
    poluchitb_granicy();
}

void KontyraWindow::on_checkBox_clicked()
{
    poluchitb_granicy();
}

void KontyraWindow::on_dial_valueChanged(int )
{
    ui->label_3->setText(QString::number(ui->dial->value()));
    poluchitb_granicy();
}

void KontyraWindow::on_dial_2_valueChanged(int )
{
    ui->label_2->setText(QString::number(ui->dial_2->value()));
    poluchitb_granicy();
}

void KontyraWindow::on_checkBox_5_clicked()
{
    poluchitb_granicy();
}

void KontyraWindow::on_spinBox_valueChanged(int arg)
{
    if (arg<(ui->spinBox_2->value()+256)) ui->spinBox_2->setValue(ui->spinBox_2->value()+256);

    switch (ui->comboBox->currentIndex())
    {
    case 0:
        a0h=ui->spinBox->value();
        break;
    case 1:
        a1h=ui->spinBox->value();
        break;
    case 2:
        a2h=ui->spinBox->value();
        break;
    case 3:
        a3h=ui->spinBox->value();
        break;
    case 4:
        a4h=ui->spinBox->value();
        break;
    case 5:
        a5h=ui->spinBox->value();
        break;
    case 6:
        a6h=ui->spinBox->value();
        break;
    case 7:
        a7h=ui->spinBox->value();
        break;
    case 8:
        a8h=ui->spinBox->value();
        break;
    }

    poluchitb_granicy();
}

void KontyraWindow::on_spinBox_2_valueChanged(int arg)
{
    if (arg>(ui->spinBox->value()-256)) ui->spinBox_2->setValue(ui->spinBox->value()-256);

    switch (ui->comboBox->currentIndex())
    {
    case 0:
        a0l=ui->spinBox_2->value();
        break;
    case 1:
        a1l=ui->spinBox_2->value();
        break;
    case 2:
        a2l=ui->spinBox_2->value();
        break;
    case 3:
        a3l=ui->spinBox_2->value();
        break;
    case 4:
        a4l=ui->spinBox_2->value();
        break;
    case 5:
        a5l=ui->spinBox_2->value();
        break;
    case 6:
        a6l=ui->spinBox_2->value();
        break;
    case 7:
        a7l=ui->spinBox_2->value();
        break;
    case 8:
        a8l=ui->spinBox_2->value();
        break;
    }

    poluchitb_granicy();
}

void KontyraWindow::on_comboBox_3_currentIndexChanged(int index)
{
    if (!guard.tryLock()) return;

    ui->comboBox->setEnabled(false);
    ui->comboBox_2->setEnabled(false);
    ui->comboBox_3->setEnabled(false);
    switch (index)
    {
    default:
        emit S345016(image1);
        break;
    case 1:
        emit S333433(image1);
        break;
    case 2:
        emit S305911(image1);
        break;
    }
}
