#ifndef KONTYRAWINDOW_H
#define KONTYRAINDOW_H

#include <QMainWindow>
#include <QGraphicsPixmapItem>
#include <QResizeEvent>
#include <QLabel>
#include <QMutex>
#include <QTableWidget>
#include <math.h>
#include <QTime>
#include <QProgressBar>
#include <QtGui>
#include <QApplication>
#include <QGraphicsScene>


class ConvertThread;


namespace Ui {
class KontyraWindow;
}

class KontyraWindow : public QMainWindow
{
    Q_OBJECT


public:
    explicit KontyraWindow(QWidget *parent = 0);
    ~KontyraWindow();


private:
    Ui::KontyraWindow *ui;
    QGraphicsScene *scene, *scene2, *scene3;
    QPixmap picture1, info_alg;
    QImage image1,imagegray;
    QString cur;
    QMutex guard;
    QTime time;
    QThread *one_more;
    ConvertThread *convert;
    int dlina_pyti;
    unsigned int a0h,a1h,a2h,a3h,a4h,a5h,a6h,a7h,a8h;
    unsigned int a0l,a1l,a2l,a3l,a4l,a5l,a6l,a7l,a8l;

    void resizeEvent(QResizeEvent* );
    void showEvent(QShowEvent *);
    void poluchitb_granicy();
    void zapolnenieInfoScene(unsigned int, int );
    void mousePressEvent(QMouseEvent *);


signals:
    void chryashchev(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void sharr(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void sobel(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void pryitt(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void roberts(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void robertsBistrij(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void laplasian(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void kirsh(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void robinson(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void tolkoSeriy(QImage ,unsigned int , unsigned int );

    void S333433(QImage );
    void S305911(QImage );
    void S345016(QImage );

    void monochrom(bool, QImage , unsigned int , unsigned int );
    void inversia(QImage , unsigned int , unsigned int );
    void postroimGradient(unsigned int , unsigned int , unsigned int );


private slots:
    void alg_exit(QImage , unsigned int , unsigned int );
    void monochrom_exit(QImage , unsigned int , unsigned int );
    void inversia_exit(QImage , unsigned int , unsigned int );
    void postroimGradient_exit(QImage , unsigned int , unsigned int );
    void obr_exit(QImage );

    void on_pushButton_2_clicked();
    void on_checkBox_2_clicked();
    void on_checkBox_clicked();
    void on_dial_valueChanged(int value);
    void on_dial_2_valueChanged(int value);
    void on_pushButton_clicked();
    void on_checkBox_5_clicked();
    void on_comboBox_currentIndexChanged(int index);
    void on_spinBox_valueChanged(int arg1);
    void on_spinBox_2_valueChanged(int arg1);
    void on_comboBox_3_currentIndexChanged(int index);
};

class ConvertThread: public QObject
{
    Q_OBJECT


public:
    explicit ConvertThread(QWidget *parent = 0);
    ~ConvertThread();


private:
    unsigned int mas[256];
    double map(double x, double fromLow, double fromHigh,
                     double toLow, double toHigh);


signals:
    void alg_exit(QImage , unsigned int , unsigned int );
    void monochrom_exit(QImage ,unsigned int ,unsigned int );
    void inversia_exit(QImage ,unsigned int ,unsigned int );
    void postroimGradient_exit(QImage , unsigned int , unsigned int );
    void obr_exit(QImage );


private slots:
    void chryashchev(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void sharr(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void sobel(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void pryitt(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void roberts(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void robertsBistrij(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void laplasian(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void kirsh(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void robinson(QImage , unsigned int , unsigned int , unsigned int , unsigned int );
    void tolkoSeriy(QImage ,unsigned int , unsigned int );

    void S333433(QImage );
    void S305911(QImage );
    void S345016(QImage );

    void monochrom(bool, QImage , unsigned int , unsigned int );
    void inversia(QImage , unsigned int , unsigned int );
    void postroimGradient(unsigned int , unsigned int , unsigned int );


};

#endif // KONTURAWINDOW_H
