﻿#include "kontyrawindow.h"


#define M_PI 3.14159265358979323846

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    KontyraWindow w;
    w.show();

    return a.exec();
}

ConvertThread::ConvertThread(QWidget *parent) :
    QObject(parent)
{
    for (int i=0;i<256;i++) mas[i]=0;
}

ConvertThread::~ConvertThread()
{

}

void ConvertThread::postroimGradient(unsigned int razmer_kartinki, unsigned int min_porog, unsigned int max_porog)
{
    razmer_kartinki-=mas[0];
    unsigned int max=0;
    for (int i=1; i<256; i++)
        if (mas[i]>max) max=mas[i];

    int razmer_shrifta=2;
    //создаем формат изображения
    max=(306*max/razmer_kartinki)+razmer_shrifta;

    QImage buf_image(255*razmer_shrifta,max+2*razmer_shrifta,QImage::Format_ARGB32_Premultiplied);
    buf_image.fill(Qt::white);

    //создаем рисовальщика с данным изображением buf_image
    QPainter paint(&buf_image);
    paint.setRenderHint(QPainter::HighQualityAntialiasing,true);

    paint.setPen(QPen(Qt::black, razmer_shrifta, Qt::SolidLine, Qt::RoundCap, Qt::RoundJoin));
    paint.drawLine(0,max+razmer_shrifta/2,256*razmer_shrifta,max+razmer_shrifta/2);
    for (int i=1; i<256; i++)
        paint.drawLine(razmer_shrifta/2+(i-1)*razmer_shrifta,max,
                       razmer_shrifta/2+(i-1)*razmer_shrifta,max-(306*mas[i]/razmer_kartinki));


    paint.setPen(QPen(Qt::green, razmer_shrifta, Qt::DotLine, Qt::RoundCap, Qt::RoundJoin));
    paint.drawLine((min_porog-1)*razmer_shrifta,max+razmer_shrifta/2,(min_porog-1)*razmer_shrifta,0);
    paint.drawLine(max_porog*razmer_shrifta,max+razmer_shrifta/2,max_porog*razmer_shrifta,0);

    emit postroimGradient_exit(buf_image,min_porog,max_porog);
}

void ConvertThread::chryashchev(QImage image,unsigned int min_porog, unsigned int max_porog,
                                unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<2;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-2;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=2;j<height-2;j++)
        for (int i=0;i<2;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=2;j<height-2;j++)
        for (int i=width-2;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=2;j<height-2;j++)
        for (int i=2;i<width-2;i++)
        {
            X=abs(
                        //0*(image.pixel(i-2,j-2)&0x000000FF)
                        +2*(image.pixel(i-1,j-2)&0x000000FF)
                        +3*(image.pixel(i  ,j-2)&0x000000FF)
                        +2*(image.pixel(i+1,j-2)&0x000000FF)
                        //+0*(image.pixel(i+2,j-2)&0x000000FF)

                        +2*(image.pixel(i-2,j-1)&0x000000FF)
                        +8*(image.pixel(i-1,j-1)&0x000000FF)
                        +14*(image.pixel(i  ,j-1)&0x000000FF)
                        //+0*(image.pixel(i+1,j-1)&0x000000FF)
                        -2*(image.pixel(i+2,j-1)&0x000000FF)

                        +3*(image.pixel(i-2,j  )&0x000000FF)
                        +14*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -14*(image.pixel(i+1,j  )&0x000000FF)
                        -3*(image.pixel(i+2,j  )&0x000000FF)

                        +2*(image.pixel(i-2,j+1)&0x000000FF)
                        //+0*(image.pixel(i-1,j+1)&0x000000FF)
                        -14*(image.pixel(i  ,j+1)&0x000000FF)
                        -8*(image.pixel(i+1,j+1)&0x000000FF)
                        -2*(image.pixel(i+2,j+1)&0x000000FF)

                        //+0*(image.pixel(i-2,j+2)&0x000000FF)
                        -2*(image.pixel(i-1,j+2)&0x000000FF)
                        -3*(image.pixel(i  ,j+2)&0x000000FF)
                        -2*(image.pixel(i+1,j+2)&0x000000FF)
                        //-0*(image.pixel(i+2,j+2)&0x000000FF)
                        );

            Y=abs(
                        //0*(image.pixel(i-2,j-2)&0x000000FF)
                        -2*(image.pixel(i-1,j-2)&0x000000FF)
                        -3*(image.pixel(i  ,j-2)&0x000000FF)
                        -2*(image.pixel(i+1,j-2)&0x000000FF)
                        //+0*(image.pixel(i+2,j-2)&0x000000FF)

                        +2*(image.pixel(i-2,j-1)&0x000000FF)
                        //+0*(image.pixel(i-1,j-1)&0x000000FF)
                        -14*(image.pixel(i  ,j-1)&0x000000FF)
                        -8*(image.pixel(i+1,j-1)&0x000000FF)
                        -2*(image.pixel(i+2,j-1)&0x000000FF)

                        +3*(image.pixel(i-2,j  )&0x000000FF)
                        +14*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -14*(image.pixel(i+1,j  )&0x000000FF)
                        -3*(image.pixel(i+2,j  )&0x000000FF)

                        +2*(image.pixel(i-2,j+1)&0x000000FF)
                        +8*(image.pixel(i-1,j+1)&0x000000FF)
                        +14*(image.pixel(i  ,j+1)&0x000000FF)
                        //+0*(image.pixel(i+1,j+1)&0x000000FF)
                        -2*(image.pixel(i+2,j+1)&0x000000FF)

                        //+0*(image.pixel(i-2,j+2)&0x000000FF)
                        +2*(image.pixel(i-1,j+2)&0x000000FF)
                        +3*(image.pixel(i  ,j+2)&0x000000FF)
                        +2*(image.pixel(i+1,j+2)&0x000000FF)
                        //+0*(image.pixel(i+2,j+2)&0x000000FF)
                        );

            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map((sqrt(pow(X,2)+pow(Y,2))),predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::sharr(QImage image,unsigned int min_porog, unsigned int max_porog,
                          unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<1;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=1;j<height-1;j++)
        for (int i=0;i<1;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=1;j<height-1;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=1;j<height-1;j++)
        for (int i=1;i<width-1;i++)
        {
            //X=(A2+2*A3+A4)-
            //  (A0+2*A7+A6)
            //Y=(A0+2*A1+A2)-
            //  (A6+2*A5+A4)
            X=abs((3*/*A2*/(image.pixel(i+1,j-1)&0x000000FF)+
                   10*/*A3*/(image.pixel(i+1,j)&0x000000FF)+
                   3*/*A4*/(image.pixel(i+1,j+1)&0x000000FF))-
                  (3*/*A0*/(image.pixel(i-1,j-1)&0x000000FF)+
                   10*/*A7*/(image.pixel(i-1,j)&0x000000FF)+
                   3*/*A6*/(image.pixel(i-1,j+1)&0x000000FF)));

            Y=abs((3*/*A0*/(image.pixel(i-1,j-1)&0x000000FF)+
                   10*/*A1*/(image.pixel(i,j-1)&0x000000FF)+
                   3*/*A2*/(image.pixel(i+1,j-1)&0x000000FF))-
                  (3*/*A6*/(image.pixel(i-1,j+1)&0x000000FF)+
                   10*/*A5*/(image.pixel(i,j+1)&0x000000FF)+
                   3*/*A4*/(image.pixel(i+1,j+1)&0x000000FF)));


            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map((sqrt(pow(X,2)+pow(Y,2))),predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::sobel(QImage image,unsigned int min_porog, unsigned int max_porog,
                          unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<1;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=1;j<height-1;j++)
        for (int i=0;i<1;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=1;j<height-1;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=1;j<height-1;j++)
        for (int i=1;i<width-1;i++)
        {
            //X=(A2+2*A3+A4)-
            //  (A0+2*A7+A6)
            //Y=(A0+2*A1+A2)-
            //  (A6+2*A5+A4)
            X=abs((/*A2*/(image.pixel(i+1,j-1)&0x000000FF)+
                   2*/*A3*/(image.pixel(i+1,j)&0x000000FF)+
                   /*A4*/(image.pixel(i+1,j+1)&0x000000FF))-
                  (/*A0*/(image.pixel(i-1,j-1)&0x000000FF)+
                   2*/*A7*/(image.pixel(i-1,j)&0x000000FF)+
                   /*A6*/(image.pixel(i-1,j+1)&0x000000FF)));

            Y=abs((/*A0*/(image.pixel(i-1,j-1)&0x000000FF)+
                   2*/*A1*/(image.pixel(i,j-1)&0x000000FF)+
                   /*A2*/(image.pixel(i+1,j-1)&0x000000FF))-
                  (/*A6*/(image.pixel(i-1,j+1)&0x000000FF)+
                   2*/*A5*/(image.pixel(i,j+1)&0x000000FF)+
                   /*A4*/(image.pixel(i+1,j+1)&0x000000FF)));


            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map((sqrt(pow(X,2)+pow(Y,2))),predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::pryitt(QImage image,unsigned int min_porog, unsigned int max_porog,
                           unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<1;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=1;j<height-1;j++)
        for (int i=0;i<1;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=1;j<height-1;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=1;j<height-1;j++)
        for (int i=1;i<width-1;i++)
        {
            //X=(A2+2*A3+A4)-
            //  (A0+2*A7+A6)
            //Y=(A0+2*A1+A2)-
            //  (A6+2*A5+A4)
            X=abs((/*A2*/(image.pixel(i+1,j-1)&0x000000FF)+
                   /*A3*/(image.pixel(i+1,j)&0x000000FF)+
                   /*A4*/(image.pixel(i+1,j+1)&0x000000FF))-
                  (/*A0*/(image.pixel(i-1,j-1)&0x000000FF)+
                   /*A7*/(image.pixel(i-1,j)&0x000000FF)+
                   /*A6*/(image.pixel(i-1,j+1)&0x000000FF)));

            Y=abs((/*A0*/(image.pixel(i-1,j-1)&0x000000FF)+
                   /*A1*/(image.pixel(i,j-1)&0x000000FF)+
                   /*A2*/(image.pixel(i+1,j-1)&0x000000FF))-
                  (/*A6*/(image.pixel(i-1,j+1)&0x000000FF)+
                   /*A5*/(image.pixel(i,j+1)&0x000000FF)+
                   /*A4*/(image.pixel(i+1,j+1)&0x000000FF)));


            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map((sqrt(pow(X,2)+pow(Y,2))),predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::roberts(QImage image,unsigned int min_porog, unsigned int max_porog,
                            unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<height;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=0;j<height-1;j++)
        for (int i=0;i<width-1;i++)
        {
            X=abs(
                        (image.pixel(i  ,j  )&0x000000FF)
                        //+0*(image.pixel(i+1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j+1)&0x000000FF)
                        -(image.pixel(i+1,j+1)&0x000000FF)
                        );

            Y=abs(
                        // 0*(image.pixel(i  ,j  )&0x000000FF)
                        +(image.pixel(i+1,j  )&0x000000FF)
                        -(image.pixel(i  ,j+1)&0x000000FF)
                        //+0*(image.pixel(i+1,j+1)&0x000000FF)
                        );


            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map((sqrt(pow(X,2)+pow(Y,2))),predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::robertsBistrij(QImage image,unsigned int min_porog, unsigned int max_porog,
                                   unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<height;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=0;j<height-1;j++)
        for (int i=0;i<width-1;i++)
        {
            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            X=abs((image.pixel(i  ,j  )&0x000000FF)-(image.pixel(i+1,j+1)&0x000000FF))+
                    abs((image.pixel(i+1,j  )&0x000000FF)-(image.pixel(i  ,j+1)&0x000000FF));
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map(X,predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::laplasian(QImage image,unsigned int min_porog, unsigned int max_porog,
                              unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<1;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=1;j<height-1;j++)
        for (int i=0;i<1;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=1;j<height-1;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=1;j<height-1;j++)
        for (int i=1;i<width-1;i++)
        {
            X=abs(
                        // 0*(image.pixel(i-1,j-1)&0x000000FF)
                        +(image.pixel(i  ,j-1)&0x000000FF)
                        //+0*(image.pixel(i+1,j-1)&0x000000FF)

                        +(image.pixel(i-1,j  )&0x000000FF)
                        -4*(image.pixel(i  ,j  )&0x000000FF)
                        +(image.pixel(i+1,j  )&0x000000FF)

                        //+0*(image.pixel(i-1,j+1)&0x000000FF)
                        +(image.pixel(i  ,j+1)&0x000000FF)
                        //+0*(image.pixel(i+1,j+1)&0x000000FF)
                        );

            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map(X,predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::kirsh(QImage image,unsigned int min_porog, unsigned int max_porog,
                          unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<1;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=1;j<height-1;j++)
        for (int i=0;i<1;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=1;j<height-1;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=1;j<height-1;j++)
        for (int i=1;i<width-1;i++)
        {
            Y=abs(
                        -3*(image.pixel(i-1,j-1)&0x000000FF)
                        -3*(image.pixel(i  ,j-1)&0x000000FF)
                        -3*(image.pixel(i+1,j-1)&0x000000FF)

                        -3*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -3*(image.pixel(i+1,j  )&0x000000FF)

                        +5*(image.pixel(i-1,j+1)&0x000000FF)
                        +5*(image.pixel(i  ,j+1)&0x000000FF)
                        +5*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            X=Y;
            Y=abs(
                        -3*(image.pixel(i-1,j-1)&0x000000FF)
                        -3*(image.pixel(i  ,j-1)&0x000000FF)
                        -3*(image.pixel(i+1,j-1)&0x000000FF)

                        +5*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -3*(image.pixel(i+1,j  )&0x000000FF)

                        +5*(image.pixel(i-1,j+1)&0x000000FF)
                        +5*(image.pixel(i  ,j+1)&0x000000FF)
                        -3*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        5*(image.pixel(i-1,j-1)&0x000000FF)
                        -3*(image.pixel(i  ,j-1)&0x000000FF)
                        -3*(image.pixel(i+1,j-1)&0x000000FF)

                        +5*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -3*(image.pixel(i+1,j  )&0x000000FF)

                        +5*(image.pixel(i-1,j+1)&0x000000FF)
                        -3*(image.pixel(i  ,j+1)&0x000000FF)
                        -3*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        5*(image.pixel(i-1,j-1)&0x000000FF)
                        +5*(image.pixel(i  ,j-1)&0x000000FF)
                        -3*(image.pixel(i+1,j-1)&0x000000FF)

                        +5*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -3*(image.pixel(i+1,j  )&0x000000FF)

                        -3*(image.pixel(i-1,j+1)&0x000000FF)
                        -3*(image.pixel(i  ,j+1)&0x000000FF)
                        -3*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        5*(image.pixel(i-1,j-1)&0x000000FF)
                        +5*(image.pixel(i  ,j-1)&0x000000FF)
                        +5*(image.pixel(i+1,j-1)&0x000000FF)

                        -3*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -3*(image.pixel(i+1,j  )&0x000000FF)

                        -3*(image.pixel(i-1,j+1)&0x000000FF)
                        -3*(image.pixel(i  ,j+1)&0x000000FF)
                        -3*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        -3*(image.pixel(i-1,j-1)&0x000000FF)
                        +5*(image.pixel(i  ,j-1)&0x000000FF)
                        +5*(image.pixel(i+1,j-1)&0x000000FF)

                        -3*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        +5*(image.pixel(i+1,j  )&0x000000FF)

                        -3*(image.pixel(i-1,j+1)&0x000000FF)
                        -3*(image.pixel(i  ,j+1)&0x000000FF)
                        -3*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        -3*(image.pixel(i-1,j-1)&0x000000FF)
                        -3*(image.pixel(i  ,j-1)&0x000000FF)
                        +5*(image.pixel(i+1,j-1)&0x000000FF)

                        -3*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        +5*(image.pixel(i+1,j  )&0x000000FF)

                        -3*(image.pixel(i-1,j+1)&0x000000FF)
                        -3*(image.pixel(i  ,j+1)&0x000000FF)
                        +5*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        -3*(image.pixel(i-1,j-1)&0x000000FF)
                        -3*(image.pixel(i  ,j-1)&0x000000FF)
                        -3*(image.pixel(i+1,j-1)&0x000000FF)

                        -3*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        +5*(image.pixel(i+1,j  )&0x000000FF)

                        +5*(image.pixel(i-1,j+1)&0x000000FF)
                        +5*(image.pixel(i  ,j+1)&0x000000FF)
                        +5*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;


            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map(X,predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }

    emit alg_exit(itog_image, min_porog, max_porog);

}

void ConvertThread::robinson(QImage image,unsigned int min_porog, unsigned int max_porog,
                             unsigned int predel_min, unsigned int predel_max )
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    unsigned int X, Y;
    for (int i=0;i<256;i++) mas[i]=0;
    //граница
    for (int j=0;j<1;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=height-1;j<height;j++)
        for (int i=0;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    for (int j=1;j<height-1;j++)
        for (int i=0;i<1;i++)
            itog_image.setPixel(i,j,0xFF000000);
    for (int j=1;j<height-1;j++)
        for (int i=width-1;i<width;i++)
            itog_image.setPixel(i,j,0xFF000000);

    //центр
    for (int j=1;j<height-1;j++)
        for (int i=1;i<width-1;i++)
        {
            Y=abs(
                        -(image.pixel(i-1,j-1)&0x000000FF)
                        -2*(image.pixel(i  ,j-1)&0x000000FF)
                        -(image.pixel(i+1,j-1)&0x000000FF)

                        //+0*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        //+0*(image.pixel(i+1,j  )&0x000000FF)

                        +(image.pixel(i-1,j+1)&0x000000FF)
                        +2*(image.pixel(i  ,j+1)&0x000000FF)
                        +(image.pixel(i+1,j+1)&0x000000FF)
                        );
            X=Y;
            Y=abs(
                        //+0*(image.pixel(i-1,j-1)&0x000000FF)
                        -(image.pixel(i  ,j-1)&0x000000FF)
                        -2*(image.pixel(i+1,j-1)&0x000000FF)

                        +(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -(image.pixel(i+1,j  )&0x000000FF)

                        +2*(image.pixel(i-1,j+1)&0x000000FF)
                        +(image.pixel(i  ,j+1)&0x000000FF)
                        //+0*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        (image.pixel(i-1,j-1)&0x000000FF)
                        //+0*(image.pixel(i  ,j-1)&0x000000FF)
                        -(image.pixel(i+1,j-1)&0x000000FF)

                        +2*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -2*(image.pixel(i+1,j  )&0x000000FF)

                        +(image.pixel(i-1,j+1)&0x000000FF)
                        //+0*(image.pixel(i  ,j+1)&0x000000FF)
                        -(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        2*(image.pixel(i-1,j-1)&0x000000FF)
                        +(image.pixel(i  ,j-1)&0x000000FF)
                        //+0*(image.pixel(i+1,j-1)&0x000000FF)

                        +(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        -(image.pixel(i+1,j  )&0x000000FF)

                        //+0*(image.pixel(i-1,j+1)&0x000000FF)
                        -(image.pixel(i  ,j+1)&0x000000FF)
                        -2*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        (image.pixel(i-1,j-1)&0x000000FF)
                        +2*(image.pixel(i  ,j-1)&0x000000FF)
                        +(image.pixel(i+1,j-1)&0x000000FF)

                        //+0*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        //+0*(image.pixel(i+1,j  )&0x000000FF)

                        -(image.pixel(i-1,j+1)&0x000000FF)
                        -2*(image.pixel(i  ,j+1)&0x000000FF)
                        -(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        //+0*(image.pixel(i-1,j-1)&0x000000FF)
                        +(image.pixel(i  ,j-1)&0x000000FF)
                        +2*(image.pixel(i+1,j-1)&0x000000FF)

                        -(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        +(image.pixel(i+1,j  )&0x000000FF)

                        -2*(image.pixel(i-1,j+1)&0x000000FF)
                        -(image.pixel(i  ,j+1)&0x000000FF)
                        //+0*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        -(image.pixel(i-1,j-1)&0x000000FF)
                        //+0*(image.pixel(i  ,j-1)&0x000000FF)
                        +(image.pixel(i+1,j-1)&0x000000FF)

                        -2*(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        +2*(image.pixel(i+1,j  )&0x000000FF)

                        -(image.pixel(i-1,j+1)&0x000000FF)
                        //+0*(image.pixel(i  ,j+1)&0x000000FF)
                        +(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;
            Y=abs(
                        -2*(image.pixel(i-1,j-1)&0x000000FF)
                        -(image.pixel(i  ,j-1)&0x000000FF)
                        //+0*(image.pixel(i+1,j-1)&0x000000FF)

                        -(image.pixel(i-1,j  )&0x000000FF)
                        //+0*(image.pixel(i  ,j  )&0x000000FF)
                        +(image.pixel(i+1,j  )&0x000000FF)

                        //+0*(image.pixel(i-1,j+1)&0x000000FF)
                        +(image.pixel(i  ,j+1)&0x000000FF)
                        +2*(image.pixel(i+1,j+1)&0x000000FF)
                        );
            if (X<Y) X=Y;


            //ограничение 8битного изображения на выходе
            //256+2*256+256-(0+2*-0)=1024
            //максимальный градиент = sqrt(1024^2+1024^2)=1448.15
            //в случае 16 битного 65535 - нормировать не надо.
            //делаем нормировку 0..1144 в 0..256 (x*256/1448)
            if (X>=predel_min)
                if (X<=predel_max)
                    X=map((sqrt(pow(X,2)+pow(Y,2))),predel_min,predel_max,0,255);
                else X=255;
            else X=0;



            Y=X;
            X=0xFF000000+0x00010000*X+0x00000100*X+X;

            //установка порогов
            if (Y>=min_porog)
                if (Y<=max_porog)
                {
                    itog_image.setPixel(i,j,X);
                    //наполняем гистограмму
                    mas[Y]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::tolkoSeriy(QImage image,unsigned int min_porog, unsigned int max_porog)
{
    int width, height;
    width=image.width();
    height=image.height();


    QImage itog_image(width,height,QImage::Format_Grayscale8);
    for (int i=0;i<256;i++) mas[i]=0;

    //центр
    for (int j=0;j<height;j++)
        for (int i=0;i<width;i++)
        {
            //установка порогов
            if ((image.pixel(i,j)&0x000000FF)>=min_porog)
                if ((image.pixel(i,j)&0x000000FF)<=max_porog)
                {
                    itog_image.setPixel(i,j,image.pixel(i,j));
                    //наполняем гистограмму
                    mas[image.pixel(i,j)&0x000000FF]++;
                }
                else
                {
                    itog_image.setPixel(i,j,0xFF000000);
                    mas[0]++;
                }
            else
            {
                itog_image.setPixel(i,j,0xFF000000);
                mas[0]++;
            }
        }
    emit alg_exit(itog_image, min_porog, max_porog);
}

void ConvertThread::monochrom(bool inv, QImage image,unsigned int min_porog,
                              unsigned int max_porog)
{
    int width, height;
    width=image.width();
    height=image.height();

    QImage itog_image(width,height,QImage::Format_Mono);
    for (int j=0;j<height;j++)
        for (int i=0;i<width;i++)
        {
            if (inv)
                if (image.pixel(i,j)<0xFFFFFFFF) itog_image.setPixel(i,j,0);
                else itog_image.setPixel(i,j,1);
            else
                if (image.pixel(i,j)>0xFF000000) itog_image.setPixel(i,j,1);
                else itog_image.setPixel(i,j,0);
        }

    emit monochrom_exit(itog_image, min_porog, max_porog);
}
void ConvertThread::inversia(QImage image,unsigned int min_porog, unsigned int max_porog)
{
    int width, height;
    width=image.width();
    height=image.height();

    QImage itog_image(width,height,QImage::Format_Grayscale8);
    for (int j=0;j<height;j++)
        for (int i=0;i<width;i++)
        {
            itog_image.setPixel(i,j,0xFFFFFFFF-image.pixel(i,j)+0xFF000000);
        }

    emit inversia_exit(itog_image, min_porog, max_porog);
}

double ConvertThread::map(double x, double fromLow, double fromHigh, double toLow, double toHigh)
{
    return (x-fromLow)*(toHigh-toLow)/(fromHigh-fromLow)+toLow;
}

void ConvertThread::S333433(QImage image)
{
    QImage itog_image(image.width(),image.height(),QImage::Format_Grayscale8);
    unsigned int X;
    for (int j=0;j<image.height();j++)
        for (int i=0;i<image.width();i++)
        {
            X=0.32*((image.pixel(i,j)>>16)&0x000000FF)+
                    0.36*((image.pixel(i,j)>>8)&0x000000FF)+
                    0.32*(image.pixel(i,j)&0x000000FF);

            X=0xFF000000+0x00010000*X+0x00000100*X+X;
            itog_image.setPixel(i,j,X);
        }
    emit obr_exit(itog_image);
}
void ConvertThread::S305911(QImage image)
{
    QImage itog_image(image.width(),image.height(),QImage::Format_Grayscale8);
    unsigned int X;
    for (int j=0;j<image.height();j++)
        for (int i=0;i<image.width();i++)
        {
            X=0.30*((image.pixel(i,j)>>16)&0x000000FF)+
                    0.59*((image.pixel(i,j)>>8)&0x000000FF)+
                    0.11*(image.pixel(i,j)&0x000000FF);

            X=0xFF000000+0x00010000*X+0x00000100*X+X;
            itog_image.setPixel(i,j,X);
        }
    emit obr_exit(itog_image);
}
void ConvertThread::S345016(QImage image)
{
    QImage itog_image(image.width(),image.height(),QImage::Format_Grayscale8);
    for (int j=0;j<image.height();j++)
        for (int i=0;i<image.width();i++)
        {
            itog_image.setPixel(i,j,image.pixel(i,j));
        }
    emit obr_exit(itog_image);
}

