#include "visualkontyr.h"
#include <QWheelEvent>
#include <QGraphicsItem>
#include <QScrollBar>

VisualKontyr::VisualKontyr(QWidget *parent):
    QGraphicsView (parent)
{
    glav_pos.setX(0);
    glav_pos.setY(0);
    center_pos.setX(0);
    center_pos.setY(0);
    predel_max_pos_x=0;
    predel_min_pos_x=0;
    predel_max_pos_y=0;
    predel_min_pos_y=0;
    this->setCursor(Qt::ArrowCursor);
}

VisualKontyr::~VisualKontyr()
{

}

void VisualKontyr::wheelEvent(QWheelEvent* event)
{
    if (this->scene()!=NULL)
    {
        this->setCursor(Qt::CrossCursor);

        if (event->delta()>0)
        {
            this->scale(1.03,1.03);
            if (sinhron!=NULL) sinhron->scale(1.03,1.03);
        }
        if (event->delta()<0)
        {
            this->scale(0.97,0.97);
            if (sinhron!=NULL) sinhron->scale(0.97,0.97);
        }

        QPoint buf_center;
        buf_center.setX(this->width()/2);
        buf_center.setY(this->height()/2);
        center_pos=this->mapToScene(buf_center);

        QPointF pos;
        //переводим в координаты участка общего рисунка,
        //соответствующего координаты ограниченного обзора
        //GraphicsView
        pos=this->mapToScene(event->pos());

        pos.setX(center_pos.x()+(pos.x()-center_pos.x())/28);
        pos.setY(center_pos.y()+(pos.y()-center_pos.y())/28);
        center_pos=pos;


        this->centerOn(pos);
        if (sinhron!=NULL) sinhron->centerOn(pos);
    }
}

void VisualKontyr::mouseMoveEvent(QMouseEvent * event)
{
    if (this->scene()!=NULL)
    {
        QPointF pos;
        //переводим в координаты участка общего рисунка,
        //соответствующего координаты ограниченного обзора
        //GraphicsView
        pos=this->mapToScene(event->pos());
        if (event->buttons()==Qt::RightButton)
        {
            this->setCursor(Qt::SizeAllCursor);

            pos.setX(center_pos.x()+(pos.x()-center_pos.x())/12);
            pos.setY(center_pos.y()+(pos.y()-center_pos.y())/12);
        }
        else
        {
            this->setCursor(Qt::ClosedHandCursor);

            if (horizontalScrollBar()->value()==this->horizontalScrollBar()->maximum())
            {
                if (predel_max_pos_x==0) predel_max_pos_x=pos.x();
                if (pos.x()<=predel_max_pos_x) pos.setX(predel_max_pos_x);
            }
            if (horizontalScrollBar()->value()==this->horizontalScrollBar()->minimum())
            {
                if (predel_min_pos_x==0) predel_min_pos_x=pos.x();
                if (pos.x()>=predel_min_pos_x) pos.setX(predel_min_pos_x);
            }
            pos.setX(center_pos.x()+(glav_pos.x()-pos.x()));

            if (verticalScrollBar()->value()==this->verticalScrollBar()->maximum())
            {
                if (predel_max_pos_y==0) predel_max_pos_y=pos.y();
                if (pos.y()<=predel_max_pos_y) pos.setY(predel_max_pos_y);
            }
            if (verticalScrollBar()->value()==this->verticalScrollBar()->minimum())
            {
                if (predel_min_pos_y==0) predel_min_pos_y=pos.y();
                if (pos.y()>=predel_min_pos_y) pos.setY(predel_min_pos_y);
            }
            pos.setY(center_pos.y()+(glav_pos.y()-pos.y()));
        }
        center_pos=pos;
        this->centerOn(pos);
        if (sinhron!=NULL) sinhron->centerOn(pos);
    }
}

void VisualKontyr::mousePressEvent(QMouseEvent * event)
{
    if (this->scene()!=NULL)
    {
        if (event->buttons()==Qt::RightButton)
        {
            this->setCursor(Qt::SizeAllCursor);

            QPointF pos;
            //переводим в координаты участка общего рисунка,
            //соответствующего координаты ограниченного обзора
            //GraphicsView
            pos=this->mapToScene(event->pos());
            pos.setX(center_pos.x()+(pos.x()-center_pos.x())/12);
            pos.setY(center_pos.y()+(pos.y()-center_pos.y())/12);

            center_pos=pos;
            this->centerOn(pos);
            if (sinhron!=NULL) sinhron->centerOn(pos);
        }
        else
        {
            predel_max_pos_x=0;
            predel_min_pos_x=0;
            predel_max_pos_y=0;
            predel_min_pos_y=0;
            this->setCursor(Qt::ClosedHandCursor);

            glav_pos=this->mapToScene(event->pos());

            QPoint buf_center;
            buf_center.setX(this->width()/2);
            buf_center.setY(this->height()/2);
            center_pos=this->mapToScene(buf_center);
        }
    }
}

void VisualKontyr::mouseReleaseEvent(QMouseEvent *)
{
    if (this->scene()!=NULL)
    {
        this->setCursor(Qt::OpenHandCursor);
    }
}

void VisualKontyr::mouseDoubleClickEvent(QMouseEvent *)
{
    if (this->scene()!=NULL)
    {
        this->fitInView(this->sceneRect(),Qt::KeepAspectRatio);
        if (sinhron!=NULL) sinhron->fitInView(sinhron->sceneRect(),Qt::KeepAspectRatio);
        this->fitInView(this->sceneRect(),Qt::KeepAspectRatio);
        if (sinhron!=NULL) sinhron->fitInView(sinhron->sceneRect(),Qt::KeepAspectRatio);
    }
}

